﻿function ShowMsg(...)
	return print('|cffFCF75E'..L["addon_name"]..'|r:', ...)
end

-- Slash commands ---------------------------------------------
SLASH_MSS1 = "/mss"
SlashCmdList["MSS"] = function(str)
	local input, input2 = strsplit(" ", str)
	if input == "lock" then 	
		Option_Command_Lock(1)
		ShowMsg("Locked")
	elseif input == "unlock" then
		Option_Command_Lock(0)
		ShowMsg("Unlocked")
	elseif input == "show" then
		Option_Command_EnableMSS(1)
		Option_Command_EnableTalentBar(1)
	elseif input == "hide" then
		Option_Command_EnableMSS(0)
		Option_Command_EnableTalentBar(0)
	elseif input == "symbiosis" then
		Option_Command_ShowSymbiosis()
	else
		InterfaceOptionsFrame_OpenToCategory(MSS_OptionsPanel)
		ShowMsg("/mss lock")
		ShowMsg("/mss unlock")
		ShowMsg("/mss show")
		ShowMsg("/mss hide")
		ShowMsg("/mss symbiosis")
		
	end
end

-- Option Panel 
function OptionsPanel_OnLoad(panel)	
	panel.name = L["addon_name"];		
	panel.okay = function(self) end	
	-- panel.cancel = function (self) end	
	InterfaceOptions_AddCategory(panel);
	
	
end

-- Load from saved variables
function LoadOptions(self, event, ...) 
	local name = select(1, ...)
	if event == "ADDON_LOADED" and name == "MasterShapeShifter" then		
		-- Initialize default values
		if not MSS_SavedOptions then	
			MSS_SavedOptions = {}
			MSS_SavedOptions["lock"] = 0
			MSS_SavedOptions["disable_mouse"] = 0
			MSS_SavedOptions["enable_mss"] = 1
			MSS_SavedOptions["enable_talentbar"] = 1
			MSS_SavedOptions["detach"] = 0
			MSS_SavedOptions["hide_no_combat"] = 0
			MSS_SavedOptions["lock_float_icon"] = 1
			MSS_SavedOptions["ui_scale"] = 1.0
			MSS_SavedOptions["enable_minimap"] = 1
			MSS_SavedOptions["minimap_angle"] = 0
			MSS_SavedOptions["switch_on_shapeshift"] = 0
			ShowMsg("No profile found. Set to default")
		end
		
		-- Apply options
		Option_Command_Lock(MSS_SavedOptions["lock"])	
		Option_Command_DisableMouse(MSS_SavedOptions["disable_mouse"])
		Option_Command_EnableMSS(MSS_SavedOptions["enable_mss"])						
		Option_Command_Detach(MSS_SavedOptions["detach"])
		Option_Command_HideNoCombat(MSS_SavedOptions["hide_no_combat"])	
		Option_Command_LockFloatIcon(MSS_SavedOptions["lock_float_icon"])			
		Option_Command_SetScale(MSS_SavedOptions["ui_scale"])
		Option_Command_LoadMinimapPosition()
		Option_Command_SetChangePowerBarOnShapeshift(MSS_SavedOptions["switch_on_shapeshift"])
		Option_Command_EnableMinimapButton(MSS_SavedOptions["enable_minimap"])
		
				
		
		if MSS_SavedOptions["enable_talentbar"] == 1 then
			local loaded, reason = LoadAddOn("MasterShapeShifter_Talentbar")
			if loaded then				
				Option_Command_EnableTalentBar(MSS_SavedOptions["enable_talentbar"])
			else 
				ShowMsg("TalentActionBar couldn't load...")
				ShowMsg("Reason: "..reason)
			end
		end
		
		local class, classTag = UnitClass("player")
		if classTag ~= "DRUID" then
			Option_Command_EnableMSS(0)
			Option_Command_EnableTalentBar(0)
			MSS_OptionPanel_CheckButton_EnableMSS:Disable()
			MSS_OptionPanel_CheckButton_EnableTalentBar:Disable()	
		end


	end
end

-- Option commands -------------
function Option_Command_Lock(flag)
	MSS_SavedOptions["lock"] = flag
	if flag == 1 then
		MSS_OptionPanel_CheckButton_Lock:SetChecked(true)
	else
		MSS_OptionPanel_CheckButton_Lock:SetChecked(false)
	end
	
	if flag == 1 then -- lock
		MasterSSMask:RegisterForDrag("")
		MasterSS_ComboFrame:RegisterForDrag("")		
		--MSS_TalentBar:RegisterForDrag("")	
		
		
		
	else --unlock
		MasterSSMask:RegisterForDrag("LeftButton")
		--MSS_TalentBar:RegisterForDrag("LeftButton")
		if MSS_SavedOptions["detach"] == 1 then
			MasterSS_ComboFrame:RegisterForDrag("LeftButton")		
		end		
		
	end
end

function Option_Command_DisableMouse(flag)
	MSS_SavedOptions["disable_mouse"] = flag
	if flag == 1 then
		MSS_OptionPanel_CheckButton_DisableMouse:SetChecked(true)
		MasterSSMask:EnableMouse(false)
		MasterSS:EnableMouse(false)
		MasterSS_ComboFrame:EnableMouse(false)
	else
		MSS_OptionPanel_CheckButton_DisableMouse:SetChecked(false)
		MasterSSMask:EnableMouse(true)
		MasterSS:EnableMouse(true)
		MasterSS_ComboFrame:EnableMouse(true)
	end	
end

local function SetVisible(flag)	
	if flag == 0 then
		MasterSSMask:Hide()
		MasterSS:Hide()			
	else 
		MasterSSMask:Show()
		MasterSS:Show()			
	end		
end

function Option_Command_EnableMSS(flag)
	MSS_SavedOptions["enable_mss"] = flag
	if flag == 1 then
		MSS_OptionPanel_CheckButton_EnableMSS:SetChecked(true)
	else
		MSS_OptionPanel_CheckButton_EnableMSS:SetChecked(false)
	end	
	SetVisible(flag)
end



function Option_Command_Detach(flag)
	MSS_SavedOptions["detach"] = flag
	if flag == 1 then
		MSS_OptionPanel_CheckButton_DetachComboFrame:SetChecked(true)
	else
		MSS_OptionPanel_CheckButton_DetachComboFrame:SetChecked(false)
	end
	
	if flag == 1 then
		MasterSS_ComboFrame:ClearAllPoints()	
		if MSS_SavedOptions["lock"] == 0 then
				MasterSS_ComboFrame:RegisterForDrag("LeftButton")		
		end
	else 
		MasterSS_ComboFrame:ClearAllPoints()
		MasterSS_ComboFrame:SetPoint("BOTTOMRIGHT", MasterSS, "TOPRIGHT", -20, -15)
		MasterSS_ComboFrame:RegisterForDrag("")		
	end
end

function Option_Command_HideNoCombat(flag)
	MSS_SavedOptions["hide_no_combat"] = flag
	if flag == 1 then
		MSS_OptionPanel_CheckButton_HideNoCombat:SetChecked(true)
		MasterSS:Hide()
		MasterSSMask:Hide()
	else
		MSS_OptionPanel_CheckButton_HideNoCombat:SetChecked(false)
		MasterSS:Show()
		MasterSSMask:Show()
	end
end

function Option_Command_LockFloatIcon(flag) 
	MSS_SavedOptions["lock_float_icon"] = flag
	local f = flag == 1
	MSS_OptionPanel_CheckButton_LockFloatIcon:SetChecked(f)
	
	if flag ==1 then
		MSS_Float_PreditorySwiftness:EnableMouse(false)
		MSS_Float_DoC:EnableMouse(false)		
	else 
		MSS_Float_PreditorySwiftness:EnableMouse(true)
		MSS_Float_DoC:EnableMouse(true)
		MSS_Float_PreditorySwiftness:RegisterForDrag("LeftButton")
		MSS_Float_DoC:RegisterForDrag("LeftButton")
	end
end

function Option_Command_SetScale(value)	
	MSS_OptionPanel_UISlider:SetValue(value)
end

function Option_Command_EnableTalentBar(flag)
	MSS_SavedOptions["enable_talentbar"] = flag	
	if not IsAddOnLoaded("MasterShapeShifter_Talentbar") then
		local loaded, reason = LoadAddOn("MasterShapeShifter_Talentbar")
			if loaded then
				ShowMsg("TalentActionBar Loaded...")									
			else 
				ShowMsg("TalentActionBar couldn't load...")
				ShowMsg("Reason: "..reason)
				return
			end
	end	
	if flag == 1 then		
		MSS_OptionPanel_CheckButton_EnableTalentBar:SetChecked(true)
		MSS_TalentBar:Show()
	else
		MSS_OptionPanel_CheckButton_EnableTalentBar:SetChecked(false)
		MSS_TalentBar:Hide()
	end		
end

function Option_Command_ShowSymbiosis()
	local loaded, reason = LoadAddOn("MasterShapeShifter_Symbiosis")
	if loaded then			
		MSS_SymbiosisFrame:Show()
	else 
		ShowMsg("Symbiosis couldn't load...")
		ShowMsg("Reason: "..reason)
	end		
end

function Option_Command_LoadMinimapPosition()
	MSS_MiniMapAngle = MSS_SavedOptions["minimap_angle"]		
	MSS_MinimapButton:UpdatePosition()
end

function Option_Command_SetChangePowerBarOnShapeshift(flag)
	MSS_SavedOptions["switch_on_shapeshift"] = flag
	if flag  == 1 then
		MSS_OptionPanel_CheckButton_SwitchOnShapeshift:SetChecked(true)
	else 
		MSS_OptionPanel_CheckButton_SwitchOnShapeshift:SetChecked(false)
	end
end

function Option_Command_EnableMinimapButton(flag)
	MSS_SavedOptions["enable_minimap"] = flag	
	if MSS_SavedOptions["enable_minimap"] == 1 then
		MSS_OptionPanel_CheckButton_EnableMinimapButton:SetChecked(true)
	else
		MSS_OptionPanel_CheckButton_EnableMinimapButton:SetChecked(false)
	end
	MSS_MinimapToggle()
end

